# Ogre::VertexAnimationTrack Class Reference

Specialised AnimationTrack for dealing with changing vertex position information. More...

`#include <OgreAnimationTrack.h>`

Inheritance diagram for Ogre::VertexAnimationTrack:

List of all members.

## Public Types

enum | TargetMode { TM_SOFTWARE, TM_HARDWARE }
| The target animation mode. More...

## Public Member Functions

| VertexAnimationTrack (Animation *parent, unsigned short handle, VertexAnimationType animType)
| Constructor.
| VertexAnimationTrack (Animation *parent, unsigned short handle, VertexAnimationType animType, VertexData *targetData, TargetMode target=TM_SOFTWARE)
| Constructor, associates with target VertexData and temp buffer (for software).
VertexAnimationType | getAnimationType (void) const
| Get the type of vertex animation we're performing.
virtual VertexMorphKeyFrame * | createVertexMorphKeyFrame (Real timePos)
| Creates a new morph KeyFrame and adds it to this animation at the given time index.
virtual VertexPoseKeyFrame * | createVertexPoseKeyFrame (Real timePos)
| Creates the single pose KeyFrame and adds it to this animation.
void | getInterpolatedKeyFrame (Real timeIndex, KeyFrame *kf) const
| This method in fact does nothing, since interpolation is not performed inside the keyframes for this type of track.
void | apply (Real timePos, Real weight=1.0, bool accumulate=false, Real scale=1.0f)

Parameters:

  | timePos | The time position in the animation to apply.
  | weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  | acculumate | Don't make weights relative to overall weights applied, make them absolute and just add.
  | scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

virtual void | applyToVertexData (VertexData *data, Real timePos, Real weight=1.0, const PoseList *poseList=0)
| As the 'apply' method but applies to specified VertexData instead of associated data.
VertexMorphKeyFrame * | getVertexMorphKeyFrame (unsigned short index) const
| Returns the morph KeyFrame at the specified index.
VertexPoseKeyFrame * | getVertexPoseKeyFrame (unsigned short index) const
| Returns the pose KeyFrame at the specified index.
void | setAssociatedVertexData (VertexData *data)
| Sets the associated VertexData which this track will update.
VertexData * | getAssociatedVertexData (void) const
| Gets the associated VertexData which this track will update.
void | setTargetMode (TargetMode m)
| Set the target mode.
TargetMode | getTargetMode (void) const
| Get the target mode.
virtual bool | hasNonZeroKeyFrames (void) const
| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.
virtual void | optimise (void)
| Optimise the current track by removing any duplicate keyframes.
VertexAnimationTrack * | _clone (Animation *newParent) const
| Clone this track (internal use only).
unsigned short | getHandle (void) const
| Get the handle associated with this track.
virtual unsigned short | getNumKeyFrames (void) const
| Returns the number of keyframes in this animation.
virtual KeyFrame * | getKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index.
virtual Real | getKeyFramesAtTime (Real timePos, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const
| Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.
virtual KeyFrame * | createKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
virtual void | removeKeyFrame (unsigned short index)
| Removes a KeyFrame by it's index.
virtual void | removeAllKeyFrames (void)
| Removes all the KeyFrames from this track.
virtual void | _keyFrameDataChanged (void) const
| Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.

## Protected Types

typedef std::vector< KeyFrame * > | KeyFrameList

## Protected Member Functions

KeyFrame * | createKeyFrameImpl (Real time)
void | applyPoseToVertexData (const Pose *pose, VertexData *data, Real influence)
| Utility method for applying pose animation.
virtual void | populateClone (AnimationTrack *clone) const
| Internal method for clone implementation.

## Protected Attributes

VertexAnimationType | mAnimationType
| Animation type.
VertexData * | mTargetVertexData
| Target to animate.
TargetMode | mTargetMode
| Mode to apply.
KeyFrameList | mKeyFrames
Animation * | mParent
unsigned short | mHandle

## Detailed Description

Specialised AnimationTrack for dealing with changing vertex position information.

See also:
  VertexAnimationType

Definition at line 377 of file OgreAnimationTrack.h.

## Member Typedef Documentation

typedef std::vector<KeyFrame*> Ogre::AnimationTrack::KeyFrameList `[protected, inherited]`

| Definition at line 151 of file OgreAnimationTrack.h.

## Member Enumeration Documentation

enum Ogre::VertexAnimationTrack::TargetMode

The target animation mode.

Enumeration values:

  TM_SOFTWARE | Interpolate vertex positions in software.
  TM_HARDWARE | Bind keyframe 1 to position, and keyframe 2 to a texture coordinate for interpolation in hardware.

Definition at line 381 of file OgreAnimationTrack.h.

## Constructor & Destructor Documentation

Ogre::VertexAnimationTrack::VertexAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle,
|  | VertexAnimationType | animType
| ) |

| Constructor.

Ogre::VertexAnimationTrack::VertexAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle,
|  | VertexAnimationType | animType,
|  | VertexData * | targetData,
|  | TargetMode | target = `TM_SOFTWARE`
| ) |

| Constructor, associates with target VertexData and temp buffer (for software).

## Member Function Documentation

VertexAnimationTrack* Ogre::VertexAnimationTrack::_clone | ( | Animation * | newParent | ) | const

| Clone this track (internal use only).

virtual void Ogre::AnimationTrack::_keyFrameDataChanged | ( | void |  | ) | const`[virtual, inherited]`

| Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data. Reimplemented in Ogre::NodeAnimationTrack. Definition at line 139 of file OgreAnimationTrack.h.

void Ogre::VertexAnimationTrack::apply | ( | Real | timePos,
|  | Real | weight = `1.0`,
|  | bool | accumulate = `false`,
|  | Real | scale = `1.0f`
| ) | `[virtual]`

Parameters:

  | timePos | The time position in the animation to apply.
  | weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  | acculumate | Don't make weights relative to overall weights applied, make them absolute and just add.
  | scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

Implements Ogre::AnimationTrack.

void Ogre::VertexAnimationTrack::applyPoseToVertexData | ( | const Pose * | pose,
|  | VertexData * | data,
|  | Real | influence
| ) | `[protected]`

| Utility method for applying pose animation.

virtual void Ogre::VertexAnimationTrack::applyToVertexData | ( | VertexData * | data,
|  | Real | timePos,
|  | Real | weight = `1.0`,
|  | const PoseList * | poseList = `0`
| ) | `[virtual]`

| As the 'apply' method but applies to specified VertexData instead of associated data.

virtual KeyFrame* Ogre::AnimationTrack::createKeyFrame | ( | Real | timePos | ) | `[virtual, inherited]`

Creates a new KeyFrame and adds it to this animation at the given time index.

Remarks:
  It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a KeyFrame at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0);

Parameters:

  | timePos | The time from which this KeyFrame will apply.

KeyFrame* Ogre::VertexAnimationTrack::createKeyFrameImpl | ( | Real | time | ) | `[protected, virtual]`

| Implements Ogre::AnimationTrack.

virtual VertexMorphKeyFrame* Ogre::VertexAnimationTrack::createVertexMorphKeyFrame | ( | Real | timePos | ) | `[virtual]`

Creates a new morph KeyFrame and adds it to this animation at the given time index.

Remarks:
  It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a KeyFrame at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0);

Parameters:

  | timePos | The time from which this KeyFrame will apply.

virtual VertexPoseKeyFrame* Ogre::VertexAnimationTrack::createVertexPoseKeyFrame | ( | Real | timePos | ) | `[virtual]`

| Creates the single pose KeyFrame and adds it to this animation.

VertexAnimationType Ogre::VertexAnimationTrack::getAnimationType | ( | void |  | ) | const

| Get the type of vertex animation we're performing. Definition at line 396 of file OgreAnimationTrack.h.

VertexData* Ogre::VertexAnimationTrack::getAssociatedVertexData | ( | void |  | ) | const

| Gets the associated VertexData which this track will update. Definition at line 436 of file OgreAnimationTrack.h.

unsigned short Ogre::AnimationTrack::getHandle | ( | void |  | ) | const`[inherited]`

| Get the handle associated with this track. Definition at line 66 of file OgreAnimationTrack.h.

void Ogre::VertexAnimationTrack::getInterpolatedKeyFrame | ( | Real | timeIndex,
|  | KeyFrame * | kf
| ) | const`[virtual]`

| This method in fact does nothing, since interpolation is not performed inside the keyframes for this type of track. Implements Ogre::AnimationTrack. Definition at line 414 of file OgreAnimationTrack.h.

virtual KeyFrame* Ogre::AnimationTrack::getKeyFrame | ( | unsigned short | index | ) | const`[virtual, inherited]`

| Returns the KeyFrame at the specified index.

virtual Real Ogre::AnimationTrack::getKeyFramesAtTime | ( | Real | timePos,
|  | KeyFrame ** | keyFrame1,
|  | KeyFrame ** | keyFrame2,
|  | unsigned short * | firstKeyIndex = `0`
| ) | const`[virtual, inherited]`

Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.

Remarks:
  At any point in time in an animation, there are either 1 or 2 keyframes which are 'active', 1 if the time index is exactly on a keyframe, 2 at all other times i.e. the keyframe before and the keyframe after.

  This method returns those keyframes given a time index, and also returns a parametric value indicating the value of 't' representing where the time index falls between them. E.g. if it returns 0, the time index is exactly on keyFrame1, if it returns 0.5 it is half way between keyFrame1 and keyFrame2 etc.

Parameters:

  | timePos | The time index in seconds.
  | keyFrame1 | Pointer to a KeyFrame pointer which will receive the pointer to the keyframe just before or at this time index.
  | keyFrame2 | Pointer to a KeyFrame pointer which will receive the pointer to the keyframe just after this time index.
  | firstKeyIndex | Pointer to an unsigned short which, if supplied, will receive the index of the 'from' keyframe incase the caller needs it.

Returns:
  Parametric value indicating how far along the gap between the 2 keyframes the timePos value is, e.g. 0.0 for exactly at 1, 0.25 for a quarter etc. By definition the range of this value is: 0.0 <= returnValue < 1.0 .

virtual unsigned short Ogre::AnimationTrack::getNumKeyFrames | ( | void |  | ) | const`[virtual, inherited]`

| Returns the number of keyframes in this animation.

TargetMode Ogre::VertexAnimationTrack::getTargetMode | ( | void |  | ) | const

| Get the target mode. Definition at line 441 of file OgreAnimationTrack.h.

VertexMorphKeyFrame* Ogre::VertexAnimationTrack::getVertexMorphKeyFrame | ( | unsigned short | index | ) | const

| Returns the morph KeyFrame at the specified index.

VertexPoseKeyFrame* Ogre::VertexAnimationTrack::getVertexPoseKeyFrame | ( | unsigned short | index | ) | const

| Returns the pose KeyFrame at the specified index.

virtual bool Ogre::VertexAnimationTrack::hasNonZeroKeyFrames | ( | void |  | ) | const`[virtual]`

| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out. Reimplemented from Ogre::AnimationTrack.

virtual void Ogre::VertexAnimationTrack::optimise | ( | void |  | ) | `[virtual]`

| Optimise the current track by removing any duplicate keyframes. Reimplemented from Ogre::AnimationTrack.

virtual void Ogre::AnimationTrack::populateClone | ( | AnimationTrack * | clone | ) | const`[protected, virtual, inherited]`

| Internal method for clone implementation.

virtual void Ogre::AnimationTrack::removeAllKeyFrames | ( | void |  | ) | `[virtual, inherited]`

| Removes all the KeyFrames from this track.

virtual void Ogre::AnimationTrack::removeKeyFrame | ( | unsigned short | index | ) | `[virtual, inherited]`

| Removes a KeyFrame by it's index.

void Ogre::VertexAnimationTrack::setAssociatedVertexData | ( | VertexData * | data | ) |

| Sets the associated VertexData which this track will update. Definition at line 434 of file OgreAnimationTrack.h.

void Ogre::VertexAnimationTrack::setTargetMode | ( | TargetMode | m | ) |

| Set the target mode. Definition at line 439 of file OgreAnimationTrack.h.

## Member Data Documentation

VertexAnimationType Ogre::VertexAnimationTrack::mAnimationType `[protected]`

| Animation type. Definition at line 457 of file OgreAnimationTrack.h.

unsigned short Ogre::AnimationTrack::mHandle `[protected, inherited]`

| Definition at line 154 of file OgreAnimationTrack.h.

KeyFrameList Ogre::AnimationTrack::mKeyFrames `[protected, inherited]`

| Definition at line 152 of file OgreAnimationTrack.h.

Animation* Ogre::AnimationTrack::mParent `[protected, inherited]`

| Definition at line 153 of file OgreAnimationTrack.h.

TargetMode Ogre::VertexAnimationTrack::mTargetMode `[protected]`

| Mode to apply. Definition at line 461 of file OgreAnimationTrack.h.

VertexData* Ogre::VertexAnimationTrack::mTargetVertexData `[protected]`

| Target to animate. Definition at line 459 of file OgreAnimationTrack.h.

The documentation for this class was generated from the following file:

- OgreAnimationTrack.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Sep 17 15:39:20 2006